package org.orbstudio;

import org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer;
import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.jface.resource.StringConverter;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.widgets.Display;
import org.orbstudio.common.AppKeys;

public class ORBStudioPreferenceInitializer extends AbstractPreferenceInitializer {
	/**
	 * Constructor
	 */
	public void initializeDefaultPreferences() {
		IPreferenceStore store = ORBStudioPlugin.getDefault().getPreferenceStore();

		// Identifer color
		Color identiferColor = Display.getDefault().getSystemColor(AppKeys.IDENTCOLOR);
		store.setDefault(AppKeys.P_IDENTCOLOR, StringConverter.asString(identiferColor.getRGB()));

		// Comment color
		Color commentColor = Display.getDefault().getSystemColor(AppKeys.COMMENTCOLOR);
		store.setDefault(AppKeys.P_COMMENTCOLOR, StringConverter.asString(commentColor.getRGB()));

		// Literal color
		Color literalColor = Display.getDefault().getSystemColor(AppKeys.LITERALCOLOR);
		store.setDefault(AppKeys.P_LITERALCOLOR, StringConverter.asString(literalColor.getRGB()));

		/**
		 * Properties for IDL Compilers. Default compiler is the Java IDL.
		 */
		store.setDefault(AppKeys.P_ORB, AppKeys.ORB_JAVAIDL);

		store.setDefault(AppKeys.P_JACORB_CMD, AppKeys.JACORB_CMD);
		store.setDefault(AppKeys.P_JACORB_CMDLINE, AppKeys.JACORB_CMDLINE);

		store.setDefault(AppKeys.P_ORBIX_CMD, AppKeys.ORBIX_CMD);
		store.setDefault(AppKeys.P_ORBIX_CMDLINE, AppKeys.ORBIX_CMDLINE);

		store.setDefault(AppKeys.P_VISIBROKER_CMD, AppKeys.VISIBROKER_CMD);
		store.setDefault(AppKeys.P_VISIBROKER_CMDLINE, AppKeys.VISIBROKER_CMDLINE);

		store.setDefault(AppKeys.P_OPENORB_CMD, AppKeys.OPENORB_CMD);
		store.setDefault(AppKeys.P_OPENORB_CMDLINE, AppKeys.OPENORB_CMDLINE);

		store.setDefault(AppKeys.P_JAVAIDL_CMD, AppKeys.JAVAIDL_CMD);
		store.setDefault(AppKeys.P_JAVAIDL_CMDLINE, AppKeys.JAVAIDL_CMDLINE);
	}

}
