package org.orbstudio.common;

import org.eclipse.swt.SWT;

public interface AppKeys {
	public final static String MARK_OUTPUTDIR = "%D%";
	public final static String MARK_IDLFILE = "%F%";

	/*
	 * Properties related ORB implementation.
	 */
	public final static String P_IDENTCOLOR = "orblife.idleditor.identifiercolor";
	public final static int IDENTCOLOR = SWT.COLOR_BLUE;

	public final static String P_COMMENTCOLOR = "orblife.idleditor.commentcolor";
	public final static int COMMENTCOLOR = SWT.COLOR_GRAY;

	public final static String P_LITERALCOLOR = "orblife.idleditor.literalcolor";
	public final static int LITERALCOLOR = SWT.COLOR_RED;

	public final static String P_ORB = "orblife.orb";
	public final static String ORB_JACORB = "jacorb";
	public final static String ORB_ORBIX = "orbix";
	public final static String ORB_OPENORB = "openorb";
	public final static String ORB_VISIBROKER = "visibroker";
	public final static String ORB_JAVAIDL = "javaidl";

	/*
	 * Properties related JacORB
	 */
	public final static String P_JACORB_CMD = "orblife.orb.jacorb.idl.cmd";
	public final static String JACORB_CMD = "java";
	public final static String P_JACORB_CMDLINE = "orblife.orb.jacorb.idl.cmdline";
	public final static String JACORB_CMDLINE = "-cp \"/Tools/JacORB/lib/idl.jar;/Tools/JacORB/lib/logkit-1.2.jar\" org.jacorb.idl.parser -d %D% %F%";

	/*
	 * Properties related IONA Orbix 6.X
	 */
	public final static String P_ORBIX_CMD = "orblife.orb.orbix.idl.cmd";
	public final static String ORBIX_CMD = "idl";
	public final static String P_ORBIX_CMDLINE = "orblife.orb.orbix.idl.cmdline";
	public final static String ORBIX_CMDLINE = "-jbase=-Pmodule=pkg:-O%D% -jpoa=-Pmodule=pkg:-O%D% %F%";

	/*
	 * Properties related OpenORB
	 */
	public final static String P_OPENORB_CMD = "orblife.orb.openorb.idl.cmd";
	public final static String OPENORB_CMD = "java";
	public final static String P_OPENORB_CMDLINE = "orblife.orb.openorb.idl.cmdline";
	//	public final static String OPENORB_CMDLINE = "-Dorg.omg.CORBA.ORBClass=org.openorb.CORBA.ORB -Dorg.omg.CORBA.ORBSingletonClass=org.openorb.CORBA.ORBSingleton -classpath \\Tools\\OpenORB-1.3.1\\lib\\openorb-1.3.1.jar;\\Tools\\OpenORB-1.3.1\\lib\\openorb_tools-1.3.1.jar;\\Tools\\OpenORB-1.3.1\\lib\\avalon-framework.jar;\\Tools\\OpenORB-1.3.1\\lib\\logkit.jar  org.openorb.compiler.IdlCompiler -jdk1.4 -d %D%  %F%";
	public final static String OPENORB_CMDLINE = "-Xbootclasspath/p:/Tools/OpenORB-1.4.0/OpenORB/lib/endorsed/openorb_orb_omg-1.4.0.jar; -Dopenorb.home.path=/Tools/OpenORB-1.4.0 -jar /Tools/OpenORB-1.4.0/tools/lib/launcher.jar org.openorb.compiler.IdlCompiler -d %D%  %F%";
	/*
	 * Properties related VisiBroker
	 */
	public final static String P_VISIBROKER_CMD = "orblife.orb.visibroker.idl.cmd";
	public final static String VISIBROKER_CMD = "idl2java";
	public final static String P_VISIBROKER_CMDLINE = "orblife.orb.visibroker.idl.cmdline";
	public final static String VISIBROKER_CMDLINE = "-root_dir %D% -tie %F%";

	/*
	 * Properties related JavaIDL
	 */
	public final static String P_JAVAIDL_CMD = "orblife.orb.javaidl.idl.cmd";
	public final static String JAVAIDL_CMD = "idlj";
	public final static String P_JAVAIDL_CMDLINE = "orblife.orb.javaidl.idl.cmdline";
	public final static String JAVAIDL_CMDLINE = "-fall -fallTIE -td %D%  %F%";
}
