package org.orbstudio.common;

import java.util.Properties;

public class SystemBase {
	/**
	 * @clientCardinality 1
	 * @supplierCardinality 0..1
	 */

	/**
	 * * Holds singleton instance
	 */
	private static SystemBase instance;

	private Properties prop;

	/**
	 * prevents instantiation
	 */
	private SystemBase() {
		prop = System.getProperties();
	}

	/**
	 * Returns the singleton instance.
	 * 
	 * @return the singleton instance
	 */
	static public SystemBase getInstance() {
		if (instance == null) {
			instance = new SystemBase();
		}
		return instance;
	}

	/**
	 * isWindows() Check if we work on Windows platform.
	 * 
	 * @return
	 */
	public boolean isWindows() {
		String osname = System.getProperty("os.name");

		if (osname.indexOf("Windows") >= 0) {
			return true;
		}
		return false;
	}

	/**
	 * getPathSeparator
	 * 
	 * @return
	 */
	public String getFileSeparator() {
		return prop.getProperty("file.separator");
	}
}
