package org.orbstudio.common;

import java.io.File;

public class SystemUtil {
	/**
	 * removeDirectory()
	 * 
	 * @param fIn
	 */
	public static void removeDirectory(File fIn) {
		int i;
		File f;
		String[] as;

		if (fIn.isDirectory()) {
			as = fIn.list(); // ....Get its file names
			for (i = 0; i < as.length; i++) { // ......For every file name
				f = new File(fIn, as[i]); // ........Create file obj
				removeDirectory(f); // ..........and process it.
			}
			if (!isSVNAdminFolder(fIn)) {
				fIn.delete();
			}
			return;
		}
		if (!isSVNAdminFolder(fIn)) {
			fIn.delete();
		}
	}

	/**
	 * isSVNAdminFolder
	 * @param fIn
	 * @return
	 */
	private static boolean isSVNAdminFolder(File fIn) {
		String path = fIn.getAbsolutePath();
		path = strReplace(path, "\\", "/");
		if (path.indexOf("/.svn") > 0) {
			return true;
		}
		return false;
	}

	/**
	 * If Java 1.4 is unavailable, the following technique may be used.
	 * 
	 * @param aInput is the original String which may contain substring aOldPattern
	 * @param aOldPattern is the non-empty substring which is to be replaced
	 * @param aNewPattern is the replacement for aOldPattern
	 */
	public static String strReplace(final String aInput, final String aOldPattern, final String aNewPattern) {

		if (aOldPattern.equals("")) {
			throw new IllegalArgumentException("Old pattern must have content.");
		}

		final StringBuffer result = new StringBuffer();
		// startIdx and idxOld delimit various chunks of aInput; these
		// chunks always end where aOldPattern begins
		int startIdx = 0;
		int idxOld = 0;
		while ((idxOld = aInput.indexOf(aOldPattern, startIdx)) >= 0) {
			// grab a part of aInput which does not include aOldPattern
			result.append(aInput.substring(startIdx, idxOld));
			// add aNewPattern to take place of aOldPattern
			result.append(aNewPattern);

			// reset the startIdx to just after the current match, to see
			// if there are any further matches
			startIdx = idxOld + aOldPattern.length();
		}
		// the final chunk will go to the end of aInput
		result.append(aInput.substring(startIdx));
		return result.toString();
	}
}
