package org.orbstudio.editors;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.jface.text.IDocument;
import org.eclipse.jface.text.IDocumentPartitioner;
import org.eclipse.jface.text.rules.FastPartitioner;
import org.eclipse.ui.editors.text.FileDocumentProvider;

/**
 * @stereotype Document Provider
 */
public class IDLDocumentProvider extends FileDocumentProvider {
	/**
	 * @stereotype creates
	 */

	/**
	 * createDocument
	 */
	protected IDocument createDocument(Object element) throws CoreException {
		IDocument document = super.createDocument(element);
		if (document != null) {
			IDocumentPartitioner partitioner = new FastPartitioner(new IDLPartitionScanner(), new String[] {
			    IDLPartitionScanner.IDL_STRINGLITERAL, IDLPartitionScanner.IDL_COMMENT });
			partitioner.connect(document);
			document.setDocumentPartitioner(partitioner);
		}
		return document;
	}
}
