package org.orbstudio.editors;

import org.eclipse.jface.util.PropertyChangeEvent;
import org.eclipse.ui.editors.text.TextEditor;
import org.orbstudio.ORBStudioPlugin;

/**
 * @stereotype plug-in
 */
public class IDLEditor extends TextEditor {
	private IDLColorManager colorManager;

	/**
	 * @stereotype creates
	 */

	/**
	 * @stereotype creates
	 */

	/**
	 * Constructor
	 */
	public IDLEditor() {
		super();

		colorManager = ORBStudioPlugin.getDefault().getIDLColorManager();

		setSourceViewerConfiguration(new IDLConfiguration(colorManager));
		setDocumentProvider(new IDLDocumentProvider());

		// Setup preferences for an editor.
		setPreferenceStore(ORBStudioPlugin.getDefault().getPreferenceStore());
	}

	/**
	 * handlePreferenceStoreChanged()
	 */
	protected void handlePreferenceStoreChanged(PropertyChangeEvent event) {
		colorManager.handlePreferenceStoreChanged(event);
		super.handlePreferenceStoreChanged(event);
	}

	/**
	 * affectsTextPresentation()
	 */
	protected boolean affectsTextPresentation(PropertyChangeEvent event) {
		return super.affectsTextPresentation(event) || colorManager.affectsTextPresentation(event);
	}

	/**
	 * dispose()
	 */
	public void dispose() {
		super.dispose();
	}
}
