package org.orbstudio.popup.actions.factory;

import java.util.Vector;

import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.CoreException;

/**
 * Abstract product - an interface for a type of Product object.
 * 
 * @role __Product
 * @see IORBFactory
 */
public interface IORB {
	public String getORBpropname();

	public String getORBname();

	/**
	 * @link
	 * @shapeType PatternLink
	 * @pattern gof.AbstractFactory
	 * @supplierRole Concrete Product
	 */
	/* # private IDLImpl3 lnkIDLImpl3; */
	public int execute(String prjDirectory, String idlFileName, Vector<String> vResult, boolean bTie)
	    throws CoreException;

	public void parseErrorMessage(IResource resource, Vector<String> vResult) throws CoreException;

	public StringBuffer getORBPropertiesCode();
}
