package org.orbstudio.preferences;

import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.jface.preference.RadioGroupFieldEditor;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;
import org.orbstudio.ORBStudioPlugin;
import org.orbstudio.common.AppKeys;

public class OrbIDLCompilerPreferencePage extends FieldEditorPreferencePage implements IWorkbenchPreferencePage {
	private RadioGroupFieldEditor radioGroupFieldEditor;

	/**
	 * OrbIDLCompilerPreferencePage
	 */
	public OrbIDLCompilerPreferencePage() {
		super(FieldEditorPreferencePage.GRID);

		setPreferenceStore(ORBStudioPlugin.getDefault().getPreferenceStore());
		setDescription("Choose ORB of which you would like to make use.");
		initializeDefaults();
	}

	/**
	 * initializeDefaults
	 */
	public void initializeDefaults() {
	}

	/**
	 * createFieldEditors
	 */
	protected void createFieldEditors() {
		radioGroupFieldEditor = new RadioGroupFieldEditor(AppKeys.P_ORB, "ORB", 1, new String[][] {
		    { "IONA Orbix(&X)", AppKeys.ORB_ORBIX }, { "JacORB(&J)", AppKeys.ORB_JACORB },
		    { "Sun JavaIDL(&I)", AppKeys.ORB_JAVAIDL }, { "OpenORB(&O)", AppKeys.ORB_OPENORB },
		    { "Borland VisiBroker(&V)", AppKeys.ORB_VISIBROKER }, }, getFieldEditorParent(), true);
		addField(radioGroupFieldEditor);
	}

	/**
	 * init
	 */
	public void init(IWorkbench workbench) {
	}
}
