package org.orbstudio.preferences;

import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.jface.preference.FileFieldEditor;
import org.eclipse.jface.preference.StringFieldEditor;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;
import org.orbstudio.ORBStudioPlugin;
import org.orbstudio.common.AppKeys;

public class OrbIDLCompilerVisiBrokerPreferencePage extends FieldEditorPreferencePage implements
    IWorkbenchPreferencePage {
	/**
	 * OrbIDLCompilerVisiBrokerPreferencePage
	 */
	public OrbIDLCompilerVisiBrokerPreferencePage() {
		super(GRID);
		setPreferenceStore(ORBStudioPlugin.getDefault().getPreferenceStore());
	}

	/**
	 * createFieldEditors
	 */
	protected void createFieldEditors() {
		/*
		 * Choose the IDL compiler command.
		 */
		CompilerFileFieldEditor ffe = new CompilerFileFieldEditor(AppKeys.P_VISIBROKER_CMD, "IDL Command:", true,
		  getFieldEditorParent());
		addField(ffe);

		ffe.setFocus();

		/*
		 * Set the option into the filed.
		 */
		StringFieldEditor sfe = new StringFieldEditor(AppKeys.P_VISIBROKER_CMDLINE, "Command Options:", 48,
		  getFieldEditorParent());
		addField(sfe);
	}

	public void init(IWorkbench workbench) {
	}

	/**
	 * Custom field.
	 */
	private class CompilerFileFieldEditor extends FileFieldEditor {
		public CompilerFileFieldEditor(String name, String labelText, boolean enforceAbsolute, Composite parent) {
			super(name, labelText, enforceAbsolute, parent);

			setEmptyStringAllowed(false);
		}

		/**
		 * checkState
		 */
		protected boolean checkState() {
			return true;
		}
	}
}
