package org.orbstudio.preferences;

import org.eclipse.jface.preference.ColorFieldEditor;
import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;
import org.orbstudio.ORBStudioPlugin;
import org.orbstudio.common.AppKeys;

public class OrbIDLEditorPreferencePage extends FieldEditorPreferencePage implements IWorkbenchPreferencePage {
	/**
	 * OrbIDLEditorPreferencePage
	 * 
	 * @param title
	 * @param style
	 */
	public OrbIDLEditorPreferencePage(String title, int style) {
		super(title, style);
	}

	/**
	 * OrbIDLEditorPreferencePage
	 */
	public OrbIDLEditorPreferencePage() {
		super(FieldEditorPreferencePage.GRID);
		setPreferenceStore(ORBStudioPlugin.getDefault().getPreferenceStore());
		setDescription("Syntax coloring for CORBA IDL.");
	}

	/**
	 * createFieldEditors
	 */
	protected void createFieldEditors() {
		Composite parent = getFieldEditorParent();
		String labelText = "";

		// Reserved identifier
		labelText = "Reserved identifier(&R)";
		ColorFieldEditor colorTag = new ColorFieldEditor(AppKeys.P_IDENTCOLOR, labelText, parent);
		addField(colorTag);

		// Strings
		labelText = "Strings(&S)";
		ColorFieldEditor colorString = new ColorFieldEditor(AppKeys.P_LITERALCOLOR, labelText, parent);
		addField(colorString);

		// Comment
		labelText = "Comment(&C)";
		ColorFieldEditor colorComment = new ColorFieldEditor(AppKeys.P_COMMENTCOLOR, labelText, parent);
		addField(colorComment);
	}

	/**
	 * init
	 */
	public void init(IWorkbench workbench) {
	}
}
