package org.orbstudio.preferences;

import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;
import org.orbstudio.ORBStudioPlugin;

/**
 * This class represents a preference page that is contributed to the
 * Preferences dialog. By subclassing <samp>FieldEditorPreferencePage </samp>,
 * we can use the field support built into JFace that allows us to create a page
 * that is small and knows how to save, restore and apply itself.
 * <p>
 * This page is used to modify preferences only. They are stored in the
 * preference store that belongs to the main plug-in class. That way,
 * preferences can be accessed directly via the preference store.
 * 
 * @stereotype Preference Page
 */
public class OrbSupportPreferencePage extends FieldEditorPreferencePage implements IWorkbenchPreferencePage {
	/**
	 * OrbSupportPreferencePage
	 */
	public OrbSupportPreferencePage() {
		super(GRID);

		setPreferenceStore(ORBStudioPlugin.getDefault().getPreferenceStore());
		setDescription("General Settings for ORB Studio.");
	}

	/**
	 * Creates the field editors. Field editors are abstractions of the common GUI
	 * blocks needed to manipulate various types of preferences. Each field editor
	 * knows how to save and restore itself.
	 */
	public void createFieldEditors() {
	}

	/**
	 * init
	 */
	public void init(IWorkbench workbench) {
	}
}
