package org.orbstudio.wizards.idl;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;

import org.orbstudio.ORBStudioPlugin;

public class FactoryIDLWizard extends IDLWizardAdapter {
	/**
	 * FactoryIDLWizard
	 */
	public FactoryIDLWizard() {
		this.setWindowTitle("ORB Studio Factory IDL Wizard");
		this.title = "CORBA Factory IDL file";
		this.desc = "Create a new IDL file that has interfaces for both factory and remote objects.";
		this.idlFileName = "factory.idl";
	}

	/**
	 * openContentStream Initialize file contents with a template text stored in
	 * the project directory, /template.
	 */
	public InputStream openContentStream() {
		String contents = null;
		try {
			contents = ORBStudioPlugin.getDefault().getFactoryIDLFileTemplate().toString();
		}
		catch (IOException ex) {
			System.err.println("Not found a template file for factory IDL file. Please re-install ORB Studio.");
			ex.printStackTrace();
			return new ByteArrayInputStream(
			  "### Internal error! ### No found template for factory IDL file, please check your installation.".getBytes());
		}
		return new ByteArrayInputStream(contents.getBytes());
	}
}
