package org.orbstudio.wizards.idl;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;

import org.eclipse.core.runtime.CoreException;
import org.orbstudio.ORBStudioPlugin;

public class SimpleIDLWizard extends IDLWizardAdapter {
	/**
	 * SimpleIDLWizard
	 */
	public SimpleIDLWizard() {
		this.setWindowTitle("ORB Studio Simple IDL wizard");
		this.title = "CORBA Simple IDL file";
		this.desc = "Create a new simple IDL file.";
		this.idlFileName = "simple.idl";
	}

	/**
	 * openContentStream Initialize file contents with a template text.
	 * 
	 * @throws CoreException
	 */
	public InputStream openContentStream() {
		String contents = null;
		try {
			contents = ORBStudioPlugin.getDefault().getSimpleIDLFileTemplate().toString();
		}
		catch (IOException ex) {
			System.err.println("Not found a template file for simple IDL file. Please re-install ORB Studio.");
			ex.printStackTrace();
			return new ByteArrayInputStream(
			  "### Internal error! ### No found template for simple IDL file, please check your installation.".getBytes());
		}
		catch (Exception ex) {
			ex.printStackTrace();
		}
		return new ByteArrayInputStream(contents.getBytes());
	}
}
