package org.orbstudio.wizards.server;

import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.IWorkbench;

/**
 * @stereotype WizardPageBase
 */
public class ServerWizardPage2 extends WizardPage {
	private Button btnTIE = null;
	private Button btnServer = null;

	/**
	 * ServerWizardPage2
	 * 
	 * @param workbench
	 * @param selection
	 */
	protected ServerWizardPage2(IWorkbench workbench, IStructuredSelection selection) {
		super("");
	}

	/**
	 * createControl
	 */
	public void createControl(Composite parent) {
		Composite composite = new Composite(parent, SWT.NULL);
		GridLayout layout = new GridLayout();
		composite.setLayout(layout);
		layout.numColumns = 1;
		layout.verticalSpacing = 9;

		btnServer = new Button(composite, SWT.CHECK);
		btnServer.setText("Create server class:");
		GridData gd = new GridData(GridData.FILL_HORIZONTAL);
		btnServer.setLayoutData(gd);

		btnTIE = new Button(composite, SWT.CHECK);
		btnTIE.setText("Use TIE approach:");
		gd = new GridData(GridData.FILL_HORIZONTAL);
		btnTIE.setLayoutData(gd);

		this.setControl(composite);
	}

	/**
	 * isTie
	 * 
	 * @return
	 */
	public boolean isTie() {
		return btnTIE.getSelection();
	}

	/**
	 * isServerNeeded
	 * 
	 * @return
	 */
	public boolean isServerNeeded() {
		return btnServer.getSelection();
	}
}
